umbrello: UMLAttribute Class Reference

umbrello 2.34.0 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

Signals | Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
UMLAttribute Class Reference

Sets up attribute information. More...

`#include <attribute.h>`

Inheritance diagram for UMLAttribute:

## Signals
void | attributeChanged ()
Signals inherited from UMLObject
void | modified ()

## Public Member Functions
| UMLAttribute (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None, Uml::Visibility::Enum s=Uml::Visibility::Private, UMLObject *type=0, const QString &iv=QString())
| UMLAttribute (UMLObject *parent)
bool | operator== (const UMLAttribute &rhs) const
virtual | ~UMLAttribute ()
virtual void | copyInto (UMLObject *lhs) const
void | setName (const QString &name)
void | setVisibility (Uml::Visibility::Enum s)
virtual UMLObject * | clone () const
QString | getInitialValue () const
void | setInitialValue (const QString &iv)
QString | toString (Uml::SignatureType::Enum sig=Uml::SignatureType::NoSig, bool withStereotype=false) const
QString | getFullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
virtual void | saveToXMI (QXmlStreamWriter &writer)
virtual bool | showPropertiesDialog (QWidget *parent=0)
void | setParmKind (Uml::ParameterDirection::Enum pk)
Uml::ParameterDirection::Enum | getParmKind () const
virtual UMLClassifierList | getTemplateParams ()
Public Member Functions inherited from UMLClassifierListItem
| UMLClassifierListItem (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLClassifierListItem (UMLObject *parent)
virtual | ~UMLClassifierListItem ()
virtual void | setType (UMLObject *type)
UMLClassifier * | getType () const
void | setTypeName (const QString &type)
virtual QString | getTypeName () const
virtual QString | toString (Uml::SignatureType::Enum sig=Uml::SignatureType::NoSig, bool withStereotype=false) const
virtual void | copyInto (UMLObject *lhs) const
virtual UMLObject * | clone () const =0
Public Member Functions inherited from UMLObject
| UMLObject (const UMLObject &other)
| UMLObject (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLObject (UMLObject *parent)
| UMLObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLObject ()
bool | operator== (const UMLObject &rhs) const
virtual void | copyInto (UMLObject *lhs) const
virtual UMLObject * | clone () const
virtual void | setBaseType (ObjectType ot)
ObjectType | baseType () const
QLatin1String | baseTypeStr () const
virtual void | setID (Uml::ID::Type NewID)
virtual Uml::ID::Type | id () const
QString | doc () const
bool | hasDoc () const
void | setDoc (const QString &d)
void | setVisibility (Uml::Visibility::Enum visibility)
void | setVisibilityCmd (Uml::Visibility::Enum visibility)
Uml::Visibility::Enum | visibility () const
void | setStereotype (const QString &_name)
void | setStereotypeCmd (const QString &_name)
QString | stereotype (bool includeAdornments=false) const
void | setUMLStereotype (UMLStereotype *stereo)
UMLStereotype * | umlStereotype () const
QStringList & | tags ()
QString | package (const QString &separator=QString(), bool includeRoot=false) const
UMLPackageList | packages (bool includeRoot=false) const
bool | setUMLPackage (UMLPackage *pPkg)
UMLPackage * | umlPackage () const
void | setUMLParent (UMLObject *parent)
UMLObject * | umlParent () const
virtual void | setName (const QString &strName)
virtual void | setNameCmd (const QString &strName)
QString | name () const
virtual QString | fullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
void | setAbstract (bool bAbstract)
bool | isAbstract () const
virtual bool | showPropertiesDialog (QWidget *parent=0)
virtual bool | resolveRef ()
virtual void | saveToXMI (QXmlStreamWriter &writer)
virtual bool | loadFromXMI (QDomElement &element)
bool | loadStereotype (QDomElement &element)
void | setStatic (bool bStatic)
bool | isStatic () const
virtual bool | acceptAssociationType (Uml::AssociationType::Enum) const
void | setSecondaryId (const QString &id)
QString | secondaryId () const
void | setSecondaryFallback (const QString &id)
QString | secondaryFallback () const
void | save1 (QXmlStreamWriter &writer, const QString &type, const QString &tag=QString())
bool | isUMLActor () const
bool | isUMLArtifact () const
bool | isUMLAssociation () const
bool | isUMLAttribute () const
bool | isUMLCategory () const
bool | isUMLCheckConstraint () const
bool | isUMLClassifier () const
bool | isUMLComponent () const
bool | isUMLDatatype () const
bool | isUMLEntity () const
bool | isUMLEntityAttribute () const
bool | isUMLEntityConstraint () const
bool | isUMLEnum () const
bool | isUMLEnumLiteral () const
bool | isUMLFolder () const
bool | isUMLForeignKeyConstraint () const
bool | isUMLInstance () const
bool | isUMLInstanceAttribute () const
bool | isUMLNode () const
bool | isUMLObject () const
bool | isUMLOperation () const
bool | isUMLPackage () const
bool | isUMLPort () const
bool | isUMLRole () const
bool | isUMLStereotype () const
bool | isUMLTemplate () const
bool | isUMLUniqueConstraint () const
bool | isUMLUseCase () const
UMLActor * | asUMLActor ()
UMLArtifact * | asUMLArtifact ()
UMLAssociation * | asUMLAssociation ()
UMLAttribute * | asUMLAttribute ()
UMLCanvasObject * | asUMLCanvasObject ()
UMLCategory * | asUMLCategory ()
UMLCheckConstraint * | asUMLCheckConstraint ()
UMLClassifier * | asUMLClassifier ()
UMLClassifierListItem * | asUMLClassifierListItem ()
UMLClassifierSet * | asUMLClassifierSet ()
UMLComponent * | asUMLComponent ()
UMLDatatype * | asUMLDatatype ()
UMLEntity * | asUMLEntity ()
UMLEntityAttribute * | asUMLEntityAttribute ()
UMLEntityConstraint * | asUMLEntityConstraint ()
UMLEnum * | asUMLEnum ()
UMLEnumLiteral * | asUMLEnumLiteral ()
UMLFolder * | asUMLFolder ()
UMLForeignKeyConstraint * | asUMLForeignKeyConstraint ()
UMLInstance * | asUMLInstance ()
UMLInstanceAttribute * | asUMLInstanceAttribute ()
UMLNode * | asUMLNode ()
UMLObject * | asUMLObject ()
UMLOperation * | asUMLOperation ()
UMLPackage * | asUMLPackage ()
UMLPort * | asUMLPort ()
UMLRole * | asUMLRole ()
UMLStereotype * | asUMLStereotype ()
UMLTemplate * | asUMLTemplate ()
UMLUniqueConstraint * | asUMLUniqueConstraint ()
UMLUseCase * | asUMLUseCase ()
const UMLActor * | asUMLActor () const
const UMLArtifact * | asUMLArtifact () const
const UMLAssociation * | asUMLAssociation () const
const UMLAttribute * | asUMLAttribute () const
const UMLCanvasObject * | asUMLCanvasObject () const
const UMLCategory * | asUMLCategory () const
const UMLCheckConstraint * | asUMLCheckConstraint () const
const UMLClassifier * | asUMLClassifier () const
const UMLClassifierListItem * | asUMLClassifierListItem () const
const UMLClassifierSet * | asUMLClassifierSet () const
const UMLComponent * | asUMLComponent () const
const UMLDatatype * | asUMLDatatype () const
const UMLEntity * | asUMLEntity () const
const UMLEntityAttribute * | asUMLEntityAttribute () const
const UMLEntityConstraint * | asUMLEntityConstraint () const
const UMLEnum * | asUMLEnum () const
const UMLEnumLiteral * | asUMLEnumLiteral () const
const UMLFolder * | asUMLFolder () const
const UMLForeignKeyConstraint * | asUMLForeignKeyConstraint () const
const UMLInstance * | asUMLInstance () const
const UMLInstanceAttribute * | asUMLInstanceAttribute () const
const UMLNode * | asUMLNode () const
const UMLObject * | asUMLObject () const
const UMLOperation * | asUMLOperation () const
const UMLPackage * | asUMLPackage () const
const UMLPort * | asUMLPort () const
const UMLRole * | asUMLRole () const
const UMLStereotype * | asUMLStereotype () const
const UMLTemplate * | asUMLTemplate () const
const UMLUniqueConstraint * | asUMLUniqueConstraint () const
const UMLUseCase * | asUMLUseCase () const

## Protected Member Functions
bool | load1 (QDomElement &element)
Protected Member Functions inherited from UMLObject
void | init ()
void | maybeSignalObjectCreated ()
void | save1end (QXmlStreamWriter &writer)
virtual bool | load1 (QDomElement &element)

## Protected Attributes
QString | m_InitialValue
| text for the attribute's initial value. More...
Uml::ParameterDirection::Enum | m_ParmKind
Protected Attributes inherited from UMLObject
Uml::ID::Type | m_nId
| object's id More...
QString | m_Doc
| object's documentation More...
QPointer< UMLStereotype > | m_pStereotype
| stereotype of the object if applicable More...
QString | m_name
| objects name More...
ObjectType | m_BaseType
| objects type More...
Uml::Visibility::Enum | m_visibility
| objects visibility More...
bool | m_bAbstract
| state of whether the object is abstract or not More...
bool | m_bStatic
| flag for instance scope More...
bool | m_bCreationWasSignalled
| auxiliary to maybeSignalObjectCreated() More...
QPointer< UMLObject > | m_pSecondary
QString | m_SecondaryId
QString | m_SecondaryFallback
QStringList | m_TaggedValues
UMLObjectPrivate * | m_d
| private data More...

## Private Member Functions
void | setTemplateParams (const QString &templateParam, UMLClassifierList &templateParamList)

## Additional Inherited Members
Public Types inherited from UMLObject
enum | ObjectType { ot_Unknown = -1 , ot_UMLObject = 100 , ot_Actor , ot_UseCase , ot_Package , ot_Interface , ot_Datatype , ot_Enum , ot_Class , ot_Instance , ot_Association , ot_Attribute , ot_Operation , ot_EnumLiteral , ot_Template , ot_Component , ot_Artifact , ot_Node , ot_Stereotype , ot_Role , ot_Entity , ot_EntityAttribute , ot_Folder , ot_EntityConstraint , ot_UniqueConstraint , ot_ForeignKeyConstraint , ot_CheckConstraint , ot_Category , ot_Port , ot_InstanceAttribute , ot_SubSystem }
Public Slots inherited from UMLObject
void | emitModified ()
Static Public Member Functions inherited from UMLObject
static QString | toString (ObjectType ot)
static QString | toI18nString (ObjectType t)
static Icon_Utils::IconType | toIcon (ObjectType t)

## Detailed Description

Sets up attribute information.

This class is used to set up information for an attribute. This is like a programming attribute. It has a type, name, visibility and initial value.

Author
  Paul Hensgen phens.nosp@m.gen@.nosp@m.techi.nosp@m.e.co.nosp@m.m

See also
  UMLObject Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ UMLAttribute() [1/2]

UMLAttribute::UMLAttribute | ( | UMLObject * | parent,
|  | const QString & | name,
|  | Uml::ID::Type | id = `Uml::ID::None`,
|  | Uml::Visibility::Enum | s = `Uml::Visibility::Private`,
|  | UMLObject * | type = `0`,
|  | const QString & | iv = `QString()`
| ) |  |

Sets up an attribute.

Parameters

  parent | The parent of this UMLAttribute.
  name | The name of this UMLAttribute.
  id | The unique id given to this UMLAttribute.
  s | The visibility of the UMLAttribute.
  type | The type of this UMLAttribute.
  iv | The initial value of the attribute.

## ◆ UMLAttribute() [2/2]

UMLAttribute::UMLAttribute | ( | UMLObject * | parent | ) |
| explicit

Sets up an attribute.

Parameters

  parent | The parent of this UMLAttribute.

## ◆ ~UMLAttribute()

UMLAttribute::~UMLAttribute | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ attributeChanged

void UMLAttribute::attributeChanged | ( |  | ) |
| signal

## ◆ clone()

UMLObject * UMLAttribute::clone | ( |  | ) | const
| virtual

Make a clone of the UMLAttribute.

Implements UMLClassifierListItem.

Reimplemented in UMLEntityAttribute.

## ◆ copyInto()

void UMLAttribute::copyInto | ( | UMLObject * | lhs | ) | const
| virtual

Copy the internal presentation of this object into the UMLAttribute object.

Reimplemented from UMLClassifierListItem.

Reimplemented in UMLEntityAttribute.

## ◆ getFullyQualifiedName()

QString UMLAttribute::getFullyQualifiedName | ( | const QString & | separator = `QString()`,
|  | bool | includeRoot = `false`
| ) |  | const

Reimplement method from UMLObject.

## ◆ getInitialValue()

QString UMLAttribute::getInitialValue | ( |  | ) | const

Returns The initial value of the UMLAttribute.

Returns
  The initial value of the Attribute.

## ◆ getParmKind()

Uml::ParameterDirection::Enum UMLAttribute::getParmKind | ( |  | ) | const

## ◆ getTemplateParams()

UMLClassifierList UMLAttribute::getTemplateParams | ( |  | ) |
| virtual

Returns all the template params (if any) that are in the type of this attribute

## ◆ load1()

bool UMLAttribute::load1 | ( | QDomElement & | element | ) |
| protectedvirtual

Loads the <UML:Attribute> XMI element.

Reimplemented from UMLObject.

Reimplemented in UMLEntityAttribute.

## ◆ operator==()

bool UMLAttribute::operator== | ( | const UMLAttribute & | rhs | ) | const

Overloaded '==' operator

## ◆ saveToXMI()

void UMLAttribute::saveToXMI | ( | QXmlStreamWriter & | writer | ) |
| virtual

Creates the <UML:Attribute> XMI element.

Reimplemented from UMLObject.

Reimplemented in UMLEntityAttribute.

## ◆ setInitialValue()

void UMLAttribute::setInitialValue | ( | const QString & | iv | ) |

Sets the initial value of the UMLAttribute.

Parameters

  iv | The initial value of the UMLAttribute.

## ◆ setName()

void UMLAttribute::setName | ( | const QString & | name | ) |
| virtual

Reimplementation of method from UMLObject is required as an extra signal, attributeChanged(), is emitted.

Reimplemented from UMLObject.

## ◆ setParmKind()

void UMLAttribute::setParmKind | ( | Uml::ParameterDirection::Enum | pk | ) |

## ◆ setTemplateParams()

void UMLAttribute::setTemplateParams | ( | const QString & | templateParam,
|  | UMLClassifierList & | templateParamList
| ) |  |
| private

Puts in the param templateParamList all the template params that are in templateParam

## ◆ setVisibility()

void UMLAttribute::setVisibility | ( | Uml::Visibility::Enum | s | ) |

Reimplementation of method from UMLObject is required as an extra signal, attributeChanged(), is emitted.

## ◆ showPropertiesDialog()

bool UMLAttribute::showPropertiesDialog | ( | QWidget * | parent = `0` | ) |
| virtual

Display the properties configuration dialog for the attribute.

Reimplemented from UMLObject.

Reimplemented in UMLEntityAttribute.

## ◆ toString()

QString UMLAttribute::toString | ( | Uml::SignatureType::Enum | sig = `Uml::SignatureType::NoSig`,
|  | bool | withStereotype = `false`
| ) |  | const
| virtual

Returns a string representation of the UMLAttribute.

Parameters

  sig | If true will show the attribute type and initial value.
  withStereotype | If true will show a possible stereotype applied to the attribute.

Returns
  Returns a string representation of the UMLAttribute.

Reimplemented from UMLClassifierListItem.

Reimplemented in UMLEntityAttribute.

## Member Data Documentation

## ◆ m_InitialValue

QString UMLAttribute::m_InitialValue
| protected

text for the attribute's initial value.

## ◆ m_ParmKind

Uml::ParameterDirection::Enum UMLAttribute::m_ParmKind
| protected

The documentation for this class was generated from the following files:

- umbrello/umlmodel/attribute.h
- umbrello/umlmodel/attribute.cpp